HealthcareSoft.Web/Controllers/AppointmentController.cs
using HealthcareSoft.Data;
using HealthcareSoft.Data.IRepository;
using HealthcareSoft.Data.Model;
using HealthcareSoft.Data.Repository;
using HealthcareSoft.Web.CustomFilters;
using HealthcareSoft.Web.Models;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Net;
using System.Net.Mail;
using System.Web;
using System.Web.Mvc;
using System.Threading.Tasks;
using System.Web.UI;

namespace HealthcareSoft.Web.Controllers
{
    [CheckAuthentication]
    public class AppointmentController : Controller
    {
        IAppoinmentRepository _IAppoinmentRepository;
        public AppointmentController()
        {
            _IAppoinmentRepository = new AppoinmentRepository();
        }
        private HealthCareDBContext _objHealthCareDBContext = new HealthCareDBContext();

        public JsonResult GetDetailByPhone(string PhoneNo)
        {
            List<AddAppoinmentModel> list = new List<AddAppoinmentModel>();
            try
            {

                list = _objHealthCareDBContext.Database.SqlQuery<AddAppoinmentModel>("GetAppointmentDetailByPhoneno @PhoneNo=@PhoneNo",
                                                                                        new SqlParameter("PhoneNo", PhoneNo)).ToList();
            }
            catch (Exception ex)
            {
                return Json(ex.Message);
            }
            return Json(list, JsonRequestBehavior.AllowGet);
        }

        [HttpGet]
        public ActionResult AddAppointment()

        {
          
            AddAppoinmentModel addappoinmentmodel = new AddAppoinmentModel();
      
            //addappoinmentmodel.Selectdate = System.DateTime.Now;
            //addappoinmentmodel.IllnessList = _IAppoinmentRepository.GetIllnessList();
            //return View(addappoinmentmodel);
            return View();
        }


        [HttpPost]
        public async Task<ActionResult> AddAppointment(AddAppoinmentModel model)
        {
            if (ModelState.IsValid)
            {
                try
                {
                   
                    model.DoctorId = ApplicationSession.UserId;

                    Int64 patientId = _objHealthCareDBContext.Database.SqlQuery<Int64>("select Id from UserProfile where PhoneNo=@PhoneNo",
                                                                                    new SqlParameter("PhoneNo", model.PhoneNo)).FirstOrDefault();
                    if (patientId == 0)
                    {
                        string fullName = model.PatientName;
                        var names = fullName.Split(' ');
                        string FirstName = names[0];
                        string LastName = names[1];
                        string Password = CryptorEngine.Encrypt("12345678", true);

                        int roweffected = _objHealthCareDBContext.Database.ExecuteSqlCommand("AddAppointmentWithNewPatient @FirstName=@FirstName,@LastName=@LastName,@Email=@Email,@Password=@Password,@Address=@Address,@PhoneNo=@PhoneNo,@DoctorId=@DoctorId,@ReasonForVisit=@ReasonForVisit,@AppointmentDate=@AppointmentDate,@AppointmentTime=@AppointmentTime,@Illness=@Illness",
                                                                                               new SqlParameter("FirstName", FirstName),
                                                                                               new SqlParameter("LastName", LastName),
                                                                                               new SqlParameter("Email", (object)model.Email ?? DBNull.Value),
                                                                                               new SqlParameter("Password", Password),
                                                                                               new SqlParameter("Address", model.Address),
                                                                                               new SqlParameter("PhoneNo", model.PhoneNo),
                                                                                               new SqlParameter("DoctorId", model.DoctorId),
                                                                                               new SqlParameter("ReasonForVisit", model.ReasonForVisit),
                                                                                               new SqlParameter("AppointmentDate", model.Selectdate),
                                                                                               new SqlParameter("AppointmentTime", model.SelectTime),
                                                                                               new SqlParameter("Illness", model.Illness));
                            if (roweffected > 0)
                            {
                                if (model.Email != null)
                                {
                                    var message = new MailMessage();
                                    message.To.Add(new MailAddress(model.Email));  //replace with valid value
                                    message.From = new MailAddress("testifiedemail@gmail.com");  //replace with valid value
                                    message.Subject = "Alert! Stetho Registration";
                                    message.Body = "Please register to the Stetho mobile application";


                                    message.IsBodyHtml = true;

                                    using (var smtp = new SmtpClient())
                                    {
                                        var credential = new NetworkCredential
                                        {
                                            UserName = "testifiedemail@gmail.com",  //replace with valid value
                                            Password = "testifiedpassword@hackfree" //replace with valid value
                                        };
                                        smtp.Credentials = credential;
                                        smtp.Host = "smtp.gmail.com";
                                        smtp.Port = 587;
                                        smtp.EnableSsl = true;
                                        await smtp.SendMailAsync(message);
                                    }
                                    ViewBag.Message = "Link has been send successfully";
                                }
                            TempData["Message"] = "Appointment Added Successfully!";
                            TempData.Keep();
                            return RedirectToAction("Index", "Dashboard");
                        }
                        
                    }
                    else
                    {
                        int roweffected = _objHealthCareDBContext.Database.ExecuteSqlCommand("AddAppointment @ReasonForVisit=@ReasonForVisit,@AppointmentDate=@AppointmentDate,@AppointmentTime=@AppointmentTime,@DoctorId=@DoctorId,@PatientId=@PatientId,@Illness=@Illness",
                                                                                           new SqlParameter("ReasonForVisit", model.ReasonForVisit),
                                                                                           new SqlParameter("AppointmentDate", model.Selectdate),
                                                                                           new SqlParameter("AppointmentTime", model.SelectTime),
                                                                                           new SqlParameter("DoctorId", model.DoctorId),
                                                                                           new SqlParameter("PatientId", patientId),
                                                                                           new SqlParameter("Illness", model.Illness));
                        if (roweffected > 0)
                        {
                            TempData["Message"] = "Appointment Added Successfully!";
                            TempData.Keep();
                            return RedirectToAction("Index", "Dashboard");
                        }                       
                       
                    }
                   
                }
                catch (Exception ex)
                {
                    return Json(ex.Message);
                }                
            }
            return View();
        }


       [HttpPost]
        public JsonResult GetPatientName(string PatientName)
       {
            List<AddAppoinmentModel> list = new List<AddAppoinmentModel>();
            try
            {                
                list = _objHealthCareDBContext.Database.SqlQuery<AddAppoinmentModel>("GetPatientname @Name=@Name",
                                                                                    new SqlParameter("Name", PatientName)).ToList();
             }
            catch(Exception ex)
            {
                return Json(ex.Message);
            }
           
            return Json(list, JsonRequestBehavior.AllowGet);
        }

        [HttpGet]
        public ActionResult AppoinmentDetails(Int64? DoctorId, Int64? AppointmentId)
        {            
            try
            {
               

                Int64 PatientId = _objHealthCareDBContext.Database.SqlQuery<Int64>("select PatientId from Appointment where Id={0}", AppointmentId).FirstOrDefault();

                List<PriviousIllness> listOfPriviousIllness = _objHealthCareDBContext.Database.SqlQuery<PriviousIllness>("PriviousIllness @PatientId=@PatientId",
                                                                new SqlParameter("PatientId", PatientId)).ToList();


                if (TempData["Success"] != null)
                {
                    ViewBag.Success = TempData["Success"].ToString();
                }

HealthcareSoft.Web/Controllers/PrintReportController.cs
using HealthcareSoft.Data;
using HealthcareSoft.Data.Model;
using HealthcareSoft.Web.CustomFilters;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace HealthcareSoft.Web.Controllers
{

    //[CheckAuthentication]
    [RoutePrefix("Pdf")]
    public class PrintReportController : PdfViewController
    {
        private HealthCareDBContext _objHealthCareDBContext = new HealthCareDBContext();

        [AllowAnonymous]
        public ActionResult GetReportForPatient(Int64 appointmentId)
        {
            try
            { 

                ReportModel obj = _objHealthCareDBContext.Database.SqlQuery<ReportModel>("GetReport @AppointmentId=@AppointmentId",
                                                                                           new SqlParameter("AppointmentId", appointmentId)).FirstOrDefault();


                string imreBase64Data = Convert.ToBase64String(obj.Data);
                byte[] contents = (byte[])obj.Data;
                return File(contents, "filename.pdf");
            }
           catch(Exception ex)
            {
                return null;
            }
          
        }


        [AllowAnonymous]
        public ActionResult GetClinicalReportForPatient(Int64 appointmentId)
        {
            try
            {
                //var appointId = TempData["appID"];
                //TempData.Keep("appID");
                //string data = TempData.Peek("appID").ToString();
                ReportModel obj = _objHealthCareDBContext.Database.SqlQuery<ReportModel>("GetClinicalReport @AppointmentId=@AppointmentId",
                                                                                           new SqlParameter("AppointmentId", appointmentId)).FirstOrDefault();


                string imreBase64Data = Convert.ToBase64String(obj.Data);
                byte[] contents = (byte[])obj.Data;
                return File(contents, "application/pdf");
            }
            catch (Exception ex)
            {
                return null;
            }

        }
    }
}

HealthcareSoft.Web/Views/Appointment/AddAppointment - Copy.cshtml
@model HealthcareSoft.Data.Model.AddAppoinmentModel
@using MvcBootstrapTimepicker;

@{
    //Layout = null;
    Layout = "~/Views/Shared/_Layout.cshtml";
    HealthcareSoft.Data.Model.AddAppoinmentModel obj = new HealthcareSoft.Data.Model.AddAppoinmentModel();
}
<link rel="stylesheet" href="//code.jquery.com/ui/1.11.4/themes/smoothness/jquery-ui.css">
@*<link rel="stylesheet" type="text/css" href="css/bootstrap-timepicker.min.css">*@
<script src="//code.jquery.com/jquery-1.10.2.js"></script>
@*<script src="//code.jquery.com/ui/1.11.4/jquery-ui.js"></script>*@
@*<script type="text/javascript" src="js/bootstrap-timepicker.min.js"></script>*@

<script type="text/javascript">
    //$(document).ready(function () {
    //    alert($(this).val());
    //    $("#PN").autocomplete({
    //        source: function (request, response) {
    //            $.ajax({
    //                url: "/Appointment/GetPatientName",
    //                type: "POST",
    //                dataType: "json",
    //                data: { PatientName: $("#p-name input").val() },
    //                success: function (data) {
    //                    alert(JSON.stringify(data));
    //                    response($.map(data, function (item) {
    //                        return { label: item.PatientName, value: item.id };
    //                    }))

    //                }
    //            })
    //        },
    //        messages: {
    //            noResults: "", results: ""
    //        }
    //    });
    //})


    $(document).ready(function () {
        $("#Selectdate").datepicker();
    });
</script>


<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Stetho - Dashboard</title>
    <link rel="stylesheet" href="~/assets/css/bootstrap.min.css">
    <link rel="stylesheet" href="~/assets/css/font-awesome.min.css">
    <link href="https://fonts.googleapis.com/css?family=Open+Sans:300,400,600,700,800" rel="stylesheet">
    <link rel="stylesheet" href="~/assets/css/style.css">
    <style type="text/css">
        .icon-addon .my_timepick span {
            position: relative;
            margin: 0px;
            padding: 3px 4px;
            width: 40px;
            left: 0;
            top: 0;
            border-left: solid 1px #d8d8d8;
        }

        .icon-addon .my_timepick table tr td a i {
            position: relative;
            left: 0 !important;
            top: 0 !important;
        }

        .icon-addon .my_timepick table tr td input {
            padding: 10px 16px 10px 25px !important;
        }
    </style>
</head>
<body>
    @*<link href="//maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />*@
    <link href="~/TimePicker/bootstrap-timepicker.css" rel="stylesheet" />
    @*<link href="~/TimePicker/MvcBootstrapTimepicker.css" rel="stylesheet" />*@
    @*<script src="//ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js" type="text/javascript"></script>*@
    @*<script src="//maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" type="text/javascript"></script>*@
    <script src="~/TimePicker/bootstrap-timepicker.js" type="text/javascript"></script>
    @*<script src="~/TimePicker/MvcBootstrapTimepicker.js" type="text/javascript"></script>*@
    @using (Html.BeginForm("AddAppointment", "Appointment", FormMethod.Post))
    {

        <section>
            <div class="container-fluid">
                <div class="row">

                    <div class="db-main-outer">
                        <div class="db-main-inner">
                            <div class="inner-menu-navigation">
                                <p><a href="#">Dashboard</a> <span> > </span> <a class="active" href="#">Add Appointment</a></p>
                            </div>
                            <div class="add-appoint-form">
                                <form>
                                    <h3>Add Appointment</h3>
                                    <!-- <input type="text" name="" id="" placeholder="Patient Name"> -->
                                    <div class="form-group w-30">
                                        <div class="icon-addon addon-lg" id="PN">
                                            @Html.TextBoxFor(m => m.PatientName, new { placeholder = "patient name", required = "required", @class = "form-control", id = "p-name" })
                                            <label for="p-name" rel="tooltip" title="p-name"><span><img src="~/assets/images/form-user.png" alt=""></span></label>
                                        </div>
                                    </div>
                                    <div class="form-group w-30">
                                        <div class="icon-addon addon-lg">
                                            @Html.TextBoxFor(m => m.Email, new { placeholder = "Email", required = "required", @class = "form-control" })
                                            <label for="p-name" rel="tooltip" title="email"><span><img src="~/assets/images/form-email.png" alt=""></span></label>
                                        </div>
                                    </div>
                                    <div class="form-group w-30">
                                        <div class="icon-addon addon-lg">
                                            @Html.TextBoxFor(m => m.PhoneNumber, new { placeholder = "Phone Number", required = "required", @class = "form-control", @id = "phone" })
                                            <label for="p-name" rel="tooltip" title="name"><span><img src="~/assets/images/form-phone.png" alt=""></span></label>
                                        </div>
                                    </div>
                                    <div class="form-group w-half">
                                        <div class="icon-addon addon-lg">
                                            @Html.TextBoxFor(m => m.Address, new { placeholder = "Address", required = "required", @class = "form-control", @id = "address" })
                                            <label for="p-name" rel="tooltip" title="address"><span><img src="~/assets/images/form-location.png" alt=""></span></label>
                                        </div>
                                    </div>
                                    <div class="form-group w-half-l">
                                        <div class="icon-addon addon-lg">
                                            @Html.TextBoxFor(m => m.ReasonForVisit, new { placeholder = "Reason For Visit", required = "required", @class = "form-control", @id = "visit_reason" })
                                            <label for="p-name" rel="tooltip" title="visit_reason"><span><img src="~/assets/images/form-reason.png" alt=""></span></label>
                                        </div>
                                    </div>
                                    <div class="form-group w-small">
                                        <div class="icon-addon addon-lg">
                                            @Html.TextBoxFor(m => m.Selectdate, new { placeholder = "Select Date", required = "required", @class = "form-control" })
                                            <label for="p-name" rel="tooltip" title="s-date"><span><img src="~/assets/images/form-calender.png" alt=""></span></label>
                                        </div>
                                    </div>
                                    <div class="form-group w-small">
                                        <div class="icon-addon addon-lg">
                                            <div class="input-group bootstrap-timepicker timepicker my_timepick">
                                                @*<input id="timepicker1" type="text" class="form-control input-small" name="SelectedTime">*@
                                                @Html.TextBoxFor(m => m.SelectTime, new { placeholder = "Select Time", required = "required", @class = "form-control input-small", @name = "SelectedTime", @id = "timepicker1", @type = "text" })


                                                <span class="input-group-addon"><i class="glyphicon glyphicon-time"></i></span>
                                            </div>


                                            @*@Html.BootstrapTimePicker("SelectedTime").ContainerClass("TimePickerWidth");*@
                                            @*@Html.TextBoxFor(m => m.selectTime, new { placeholder = "Select Time", required = "required", @class = "form-control", @id = "s-time" })*@
                                            @*<label for="p-name" rel="tooltip" title="s-time"><span><img src="~/assets/images/form-calender.png" alt=""></span></label>*@
                                        </div>
                                    </div>
                                    <div class="form-group w-half-l">
                                        <div class="icon-addon addon-lg">
                                            @Html.DropDownListFor(m => m.IllnessId, new SelectList(Model.IllnessList, "Id", "Discription"), new { @class = "form-control" })
                                            <label for="p-name" rel="tooltip" title="s-time"><span><img src="~/assets/images/form-reason.png" alt=""></span></label>
                                        </div>
                                    </div>
                                    <button class="appoint-sub" type="submit">Submit</button>
                                </form>
                            </div>
                            <div class="bottom-copyright-text text-center">
                                <p>© Copyright2017 STETHO | All Rights Reserved.</p>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </section>
    }

    <script src="//code.jquery.com/ui/1.11.4/jquery-ui.js"></script>
    <script type="text/javascript">
        $('#timepicker1').timepicker();
    </script>
</body>
</html>

HealthcareSoft.Web/Views/Appointment/AppointmentHistoryByPatientId.cshtml
@model HealthcareSoft.Data.Model.AppointmentHistoryModel

@{
    //Layout = null;
}

<!DOCTYPE html>

<html>
<head>
    <meta name="viewport" content="width=device-width" />
    <title>AppointmentHistoryByPatientId</title>
</head>
<body>
    <div>
        <h4>Appointment History Of Patient</h4>
        <hr />
        @if (Model.MedicineList != null)
        {
            <dl class="dl-horizontal">
                <dt>
                    @Html.DisplayNameFor(model => model.QueueNumber)
                </dt>

                <dd>
                    @Html.DisplayFor(model => model.QueueNumber)
                </dd>

                <dt>
                    @Html.DisplayNameFor(model => model.ReasonForVisit)
                </dt>

                <dd>
                    @Html.DisplayFor(model => model.ReasonForVisit)
                </dd>

                <dt>
                    @Html.DisplayNameFor(model => model.AppointmentDate)
                </dt>

                <dd>
                    @Html.DisplayFor(model => model.AppointmentDate)
                </dd>

                <dt>
                    @Html.DisplayNameFor(model => model.AppointmentTime)
                </dt>

                <dd>
                    @Html.DisplayFor(model => model.AppointmentTime)
                </dd>

                <dt>
                    @Html.DisplayNameFor(model => model.PatientSymptoms)
                </dt>

                <dd>
                    @Html.DisplayFor(model => model.PatientSymptoms)
                </dd>

                <dt>
                    @Html.DisplayNameFor(model => model.DiseaseName)
                </dt>

                <dd>
                    @Html.DisplayFor(model => model.DiseaseName)
                </dd>

                <dt>
                    @Html.DisplayNameFor(model => model.SymptomName)
                </dt>

                <dd>
                    @Html.DisplayFor(model => model.SymptomName)
                </dd>

                <dt>
                    @Html.DisplayNameFor(model => model.AllergyName)
                </dt>

                <dd>
                    @Html.DisplayFor(model => model.AllergyName)
                </dd>

                <dt>
                    @Html.DisplayNameFor(model => model.AllergyType)
                </dt>

                <dd>
                    @Html.DisplayFor(model => model.AllergyType)
                </dd>

                <dt>
                    @Html.DisplayNameFor(model => model.RevisitTime)
                </dt>

                <dd>
                    @Html.DisplayFor(model => model.RevisitTime)
                </dd>

                <dt>
                    @Html.DisplayNameFor(model => model.ClinicalNotes)
                </dt>

                <dd>
                    @Html.DisplayFor(model => model.ClinicalNotes)
                </dd>

                <dt>
                    @Html.DisplayNameFor(model => model.Duration)
                </dt>

                <dd>
                    @Html.DisplayFor(model => model.Duration)
                </dd>

                <dt>
                    @Html.DisplayNameFor(model => model.Interval)
                </dt>

                <dd>
                    @Html.DisplayFor(model => model.Interval)
                </dd>

                <dt>
                    @Html.DisplayNameFor(model => model.Medicine)
                </dt>

                <dd>

                    <div>
                        @foreach (var item in Model.MedicineList)
                        {
                            <p>@item.Medicine</p>

                        }
                    </div>

                </dd>

            </dl>
        }
        else
        {
        <dl class="dl-horizontal">
            <dt>
                @Html.DisplayNameFor(model => model.QueueNumber)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.QueueNumber)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.ReasonForVisit)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.ReasonForVisit)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.AppointmentDate)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.AppointmentDate)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.AppointmentTime)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.AppointmentTime)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.PatientSymptoms)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.PatientSymptoms)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.DiseaseName)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.DiseaseName)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.SymptomName)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.SymptomName)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.AllergyName)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.AllergyName)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.AllergyType)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.AllergyType)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.RevisitTime)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.RevisitTime)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.ClinicalNotes)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.ClinicalNotes)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.Duration)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.Duration)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.Interval)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.Interval)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.Medicine)
            </dt>

            <dd>
                <p></p>

            </dd>

        </dl>

        }
       
    </div>
   
</body>
</html>